routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

// Admin routes
Route::name('admin.')->prefix('admin')->namespace('Admin')->group(function () {
    Route::namespace('Auth')->middleware('guest:admin')->group(function () {
        // Login
        Route::get('/', 'LoginController@showLoginForm')->name('login');
        Route::post('/', 'LoginController@login');

        // Forget and reset Password
        Route::get('forgot-password', 'ForgotPasswordController@showLinkRequestForm')->name('forgot_password');
        Route::post('forgot-password', 'ForgotPasswordController@sendResetLinkEmail');
        Route::get('password/reset/{token}/{email?}', 'ResetPasswordController@showResetForm')->name('reset_password_link');
        Route::post('password/reset', 'ResetPasswordController@reset')->name('reset_password');
    });

    // Logged in admin user required
    Route::group(['middleware' => 'auth:admin'], function () {
        // Dashboard
        Route::get('/dashboard', 'AdminController@dashboard')->name('dashboard');

        Route::resource('semesters', 'SemesterController');

        Route::resource('subjects', 'SubjectController');

        Route::resource('students', 'StudentController');

        Route::resource('exams', 'ExamController');

        Route::resource('ads', 'AdController');

        Route::resource('teachers', 'TeacherController');

        Route::resource('results', 'ResultController');

        Route::resource('departments', 'DepartmentController');

        Route::resource('libraries', 'LibraryController');

        Route::resource('books', 'BookController');

        // Profile
        Route::get('/profile', 'AdminController@profile')->name('profile');
        Route::post('/profile', 'AdminController@profileUpdate');
        Route::post('/password', 'AdminController@passwordUpdate')->name('password_update');

        // Logout
        Route::get('/logout', 'Auth\LoginController@logout')->name('logout');
    });
});

app/Result.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Result extends Model
{
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'score', 'student_id', 'exam_id'
    ];

    /**
     * Validation rules
     *
     * @return array
     **/
    public static function validationRules()
    {
        return [
            'score' => 'required|numeric',
            'student_id' => 'required|numeric|exists:students,id',
            'exam_id' => 'required|numeric|exists:exams,id',
        ];
    }

    /**
     * Get the student for the Result.
     */
    public function student()
    {
        return $this->belongsTo('App\Student');
    }

    /**
     * Get the exam for the Result.
     */
    public function exam()
    {
        return $this->belongsTo('App\Exam');
    }

    /**
     * Returns the paginated list of resources
     *
     * @return \Illuminate\Pagination\Paginator
     **/
    public static function getList()
    {
        return static::with(['student'])->paginate(10);
    }
}

app/Http/Controllers/Admin/ResultController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Result;
use App\Student;
use App\Exam;
use App\Http\Controllers\Controller;

class ResultController extends Controller
{
    /**
     * Display a list of Results.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $results = Result::getList();

        return view('admin.results.index', compact('results'));
    }

    /**
     * Show the form for creating a new Result
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $students = Student::all();
        $exams = Exam::all();

        return view('admin.results.add', compact('students', 'exams'));
    }

    /**
     * Save new Result
     *
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store()
    {
        $validatedData = request()->validate(Result::validationRules());

        $result = Result::create($validatedData);

        return redirect()->route('admin.results.index')->with([
            'type' => 'success',
            'message' => 'Result added'
        ]);
    }

    /**
     * Show the form for editing the specified Result
     *
     * @param \App\Result $result
     * @return \Illuminate\Http\Response
     */
    public function edit(Result $result)
    {
        $students = Student::all();
        $exams = Exam::all();

        return view('admin.results.edit', compact('result', 'students', 'exams'));
    }

    /**
     * Update the Result
     *
     * @param \App\Result $result
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Result $result)
    {
        $validatedData = request()->validate(
            Result::validationRules($result->id)
        );

        $result->update($validatedData);

        return redirect()->route('admin.results.index')->with([
            'type' => 'success',
            'message' => 'Result Updated'
        ]);
    }

    /**
     * Delete the Result
     *
     * @param \App\Result $result
     * @return void
     */
    public function destroy(Result $result)
    {
        $result->delete();

        return redirect()->route('admin.results.index')->with([
            'type' => 'success',
            'message' => 'Result deleted successfully'
        ]);
    }
}

resources/views/admin/results/add.blade.php
@extends('admin.layouts.app', ['page' => 'result'])

@section('title', 'Add New Result')

@section('content')
<div class="card-header">
    <div class="row">
        <div class="col-6 pt-2 h5">
            <i class="fa fa-tint"></i>
            Add New Result
        </div>
    </div>
</div>

<div class="card-body m-2">
    <form role="form" method="POST" action="{{ route('admin.results.store') }}">
        @csrf

        <div class="form-group">
            <label for="score">Score</label>
            <input type="number"
                class="form-control"
                name="score"
                required
                placeholder="Score"
                value="{{ old('score') }}"
                step="any"
                id="score"
            >
        </div>

        <div class="form-group">
            <label for="student-id">Student</label>
            <select class="form-control"
                name="student_id"
                required
                id="student-id"
            >
                @foreach ($students as $student)
                    <option value="{{ $student->id }}"
                        {{ old('student_id') == $student->id ? 'selected' : '' }}
                    >
                        {{ $student->first_name }}
                    </option>
                @endforeach
            </select>
        </div>

        <div class="form-group">
            <label for="exam-id">Exam</label>
            <select class="form-control"
                name="exam_id"
                required
                id="exam-id"
            >
                @foreach ($exams as $exam)
                    <option value="{{ $exam->id }}"
                        {{ old('exam_id') == $exam->id ? 'selected' : '' }}
                    >
                        {{ $exam->id }}
                    </option>
                @endforeach
            </select>
        </div>

        <div class="card-footer">
            <button type="submit" class="btn btn-sm btn-primary">
                Submit
            </button>

            <a class="btn btn-sm btn-danger"
                href="{{ route('admin.results.index') }}"
            >
                Cancel
            </a>
        </div>
    </form>
</div>
@endsection

resources/views/admin/results/edit.blade.php
@extends('admin.layouts.app', ['page' => 'result'])

@section('title', 'Edit Result')

@section('content')
<div class="card-header">
    <div class="row">
        <div class="col-6 pt-2 h5">
            <i class="fa fa-tint"></i>
            Edit Result
        </div>
    </div>
</div>

<div class="card-body m-2">
    <form role="form" method="POST" action="{{ route('admin.results.update', ['result' => $result->id]) }}">
        @csrf
        @method('PUT')

        <div class="form-group">
            <label for="score">Score</label>
            <input type="number"
                class="form-control"
                name="score"
                required
                placeholder="Score"
                value="{{ old('score', $result->score) }}"
                step="any"
                id="score"
            >
        </div>

        <div class="form-group">
            <label for="student-id">Student</label>
            <select class="form-control"
                name="student_id"
                required
                id="student-id"
            >
                @foreach ($students as $student)
                    <option value="{{ $student->id }}"
                        {{ old('student_id', $result->student_id) == $student->id ? 'selected' : '' }}
                    >
                        {{ $student->first_name }}
                    </option>
                @endforeach
            </select>
        </div>

        <div class="form-group">
            <label for="exam-id">Exam</label>
            <select class="form-control"
                name="exam_id"
                required
                id="exam-id"
            >
                @foreach ($exams as $exam)
                    <option value="{{ $exam->id }}"
                        {{ old('exam_id', $result->exam_id) == $exam->id ? 'selected' : '' }}
                    >
                        {{ $exam->id }}
                    </option>
                @endforeach
            </select>
        </div>

        <div class="card-footer">
            <button type="submit" class="btn btn-sm btn-primary">
                Update
            </button>

            <a class="btn btn-sm btn-danger"
                href="{{ route('admin.results.index') }}"
            >
                Cancel
            </a>
        </div>
    </form>
</div>
@endsection

resources/views/admin/results/index.blade.php
@extends('admin.layouts.app', ['page' => 'result'])

@section('title', 'Results')

@section('content')
<div class="card-header">
    <div class="row">
        <div class="col-6 pt-2 h5">
            <i class="fa fa-tint"></i>
            Results
        </div>

        <div class="col-6 text-right">
            <a class="btn btn-md btn-square btn-secondary"
                href="{{ route('admin.results.create') }}"
            >
                Add New
            </a>
        </div>
    </div>
</div>

<div class="card-body m-2">
    <table class="table table-responsive-sm">
        <thead>
            <tr>
                <th>#</th>
                <th>Score</th>
                <th>Student</th>
                <th>Action</th>
            </tr>
        </thead>

        <tbody>
            @forelse ($results as $result)
                <tr>
                    <td>{{ $result->id }}</td>
                    <td>{{ $result->score }}</td>
                    <td>{{ $result->student->first_name }}</td>
                    <td>
                        <a class="btn btn-pill btn-sm btn-warning"
                            href="{{ route('admin.results.edit', ['result' => $result->id]) }}"
                        >
                            <i class="fa fa-pencil-square-o"></i>
                        </a>

                        <form action="{{ route('admin.results.destroy', ['result' => $result->id]) }}"
                            method="POST"
                            class="inline pointer"
                        >
                            @csrf
                            @method('DELETE')

                            <a class="btn btn-pill btn-sm btn-danger"
                                onclick="if (confirm('Are you sure?')) { this.parentNode.submit() }"
                            >
                                <i class="fa fa-trash-o"></i>
                            </a>
                        </form>
                    </td>
                </tr>
            @empty
                <tr>
                    <td colspan="4">No records found</td>
                </tr>
            @endforelse
        </tbody>
    </table>

    {{ $results->links() }}
</div>
@endsection